<template>
	<div style="text-align: center;">
  		<div style="width:600px;float: left;">
  			<el-input size="small" v-model="queryPostName" placeholder="请输入查询条件" style="width :300px;float: left;margin-left: 10px;margin-bottom: 10px;"></el-input>
  			<el-button size="small" type="info" @click="search">查询</el-button>
  			<el-button size="small" type="primary" @click="handleAdd">新增</el-button>
  		</div>
			<div style="padding-right: 30px;">
		<el-table v-loading="loading" :data="tableData" border>
				<el-table-column prop="id" label="序号" width="50" v-if="isShow">
				</el-table-column>
				<el-table-column prop="postName" label="岗位名称" width="120">
				</el-table-column>
				<el-table-column prop="postDesc" label="岗位说明" width="180">
				</el-table-column>
		
				<el-table-column label="操作">
					<template slot-scope="scope">
						<el-button size="mini" @click="handleEdit(scope.row)">编辑</el-button>
						<el-button size="mini" type="danger" @click="handleDelete(scope.row.id)">删除</el-button>
					</template>
				</el-table-column>
		</el-table>
		</div>
			<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage"
			 :page-sizes="pageSizes" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="totalRows">
			</el-pagination>
			<el-dialog title="编辑信息" :visible.sync="dialogVisible" width="500px">
						<el-form :model="form" label-width="80px">
							<el-form-item label="用户编码" v-if="isShow">
								<el-input v-model="form.id"></el-input>
							</el-form-item>
							<el-form-item label="岗位名称">
								<el-input v-model="form.postName"></el-input>
							</el-form-item>
							<el-form-item label="岗位说明">
								<el-input v-model="form.postDesc"></el-input>
							</el-form-item>
							<el-form-item>
								<el-button type="success" @click="handleSave">保存</el-button>
								<el-button @click="handleCancelSave">取消</el-button>
							</el-form-item>
						</el-form>
			
					</el-dialog>
	</div>		
</template>
<script>
	import axios from '@/axios';
	export default {
		data() {
			return {
				//表格初始化参数
				tableData: [],
				currentPage: 1,
				totalRows: 0,
				pageSizes: [10, 50, 100, 200],
				pageSize: 10,
				//查询条件
				queryPostName: '',
				//录入框
				dialogVisible: false,
				form: {
					id: '',
					postName: '',
					postDesc: ''
				},
			isShow:false,
			loading: true,
			}
		},
		//界面渲染完毕调用   初始化表格参数
		mounted() {
			this.getTableData()
		},
		methods: {
			// 获取table数据
			getTableData() {
				//console.log("获取table数据getTableData")
				var url = 'SysPost/query.do'
				var param = {
					page: this.currentPage,
					rows: this.pageSize,
					postName: this.queryPostName
				}
				axios.get(url, param).then(response => {
					this.tableData = response.data.data.list
					this.totalRows = response.data.data.total
					if(response){
						this.loading=false
					} else{
						this.loading=true
					}
				});
			},
			// 修改每页条数事件
			handleSizeChange(val) {
				console.log(`每页 ${val} 条`);
				this.pageSize = val
				this.getTableData()
			},
			// 修改当前页事件
			handleCurrentChange(val) {
				console.log(`当前页: ${val}`);
				this.currentPage = val
				this.getTableData()
			},
			// 新增按钮事件
			handleAdd() {
				this.dialogVisible = true
				this.form = {
					id: '',
					postName: '',
					postDesc: ''
				}
			},
			// 编辑按钮事件
			handleEdit(row) {
				this.dialogVisible = true
				this.form = {
					id: row.id,
					postName: row.postName,
					postDesc: row.postDesc,
				}
			},
			//保存按钮事件
			handleSave(row) {
				var url = 'SysPost/save.do'
				var param = {
					id:this.form.id,
					postName: this.form.postName,
					postDesc: this.form.postDesc
				}
				axios.post(url, param).then(response => {
					if (response.data.code === 0) {
						this.$message({
							type: 'success',
							message: '修改成功!',
						});
						this.getTableData()
						this.dialogVisible = false
					} else {
						this.$message({
							type: 'error',
							message: '修改失败' + response.data.msg,
						});
					}
					// loading.close();
				});
			},
			//保存取消按钮事件   关闭编辑对话框
			handleCancelSave(row) {
				this.dialogVisible = false
			},

			// 删除按钮事件
			handleDelete(id) {
				this.$confirm('此操作将删除该数据, 是否继续?', '提示', {
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}).then(() => {
					var url = 'SysPost/remove.do'
					var param = {
						id: id
					}
					axios.post(url, param).then(response => {
						if (response.data.code === 0) {
							this.$message({
								type: 'success',
								message: '删除成功!',
							});
							this.getTableData()
						} else {
							this.$message({
								type: 'error',
								message: '删除失败' + response.data.msg
							});
						}
					});
				}).catch(() => {
					this.$message({
						type: 'info',
						message: '已取消删除'
					});
				});
			},
			// 查询按钮事件
			search() {
				this.getTableData()
			}
		}
	}
</script>
